#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Text_Display.H>
#include <FL/Fl_Button.H>

Fl_Text_Display *G_disp = 0;

void button_cb(Fl_Widget *w, void *userdata) {
    int line = (int)(long)userdata;
    G_disp->scroll(line, 0);
}

int main() {
     Fl_Window *win = new Fl_Window(200, 200);
     Fl_Button *b   = new Fl_Button(10,      10,80,20,"Scroll: 1"); b->callback(button_cb, (void*)1); b->labelsize(14);
                b   = new Fl_Button(10+80+20,10,80,20,"Scroll: 4"); b->callback(button_cb, (void*)4); b->labelsize(14);
     Fl_Text_Buffer *buff   = new Fl_Text_Buffer();
                     G_disp = new Fl_Text_Display(20, 20+25+10, 200-40, 200-40-25-10, "Display");
     G_disp->buffer(buff);
     win->resizable(*G_disp);
     win->show();
     buff->text("0001: This is a long long long long line of text.\n"
                "0002: This is a long long long long line of text.\n"
                "0003: This is a long long long long line of text.\n"
                "0004: This is a long long long long line of text.\n"
                "0005: This is a long long long long line of text.\n"
                "0006: This is a long long long long line of text.\n"
                "0007: This is a long long long long line of text.\n"
                "0008: This is a long long long long line of text.\n"
                "0009: This is a long long long long line of text.\n"
                "0010: This is a long long long long line of text.\n"
                "0011: This is a long long long long line of text.\n"
                "0012: This is a long long long long line of text.\n"
                "0013: This is a long long long long line of text.\n"
                "0014: This is a long long long long line of text.\n"
                "0015: This is a long long long long line of text.\n"
                "0016: This is a long long long long line of text.\n"
                "0017: This is a long long long long line of text.\n"
                "0018: This is a long long long long line of text.\n"
                "0019: This is a long long long long line of text.\n");
     G_disp->scroll(4, 0);
     G_disp->wrap_mode(Fl_Text_Display::WRAP_AT_BOUNDS, 0);
     return(Fl::run());
}
